// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: value.proto

#include "value.pb.h"

#include <algorithm>

#include <google/protobuf/stubs/common.h>
#include <google/protobuf/stubs/port.h>
#include <google/protobuf/stubs/once.h>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/wire_format_lite_inl.h>
#include <google/protobuf/descriptor.h>
#include <google/protobuf/generated_message_reflection.h>
#include <google/protobuf/reflection_ops.h>
#include <google/protobuf/wire_format.h>
// This is a temporary google only hack
#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
#include "third_party/protobuf/version.h"
#endif
// @@protoc_insertion_point(includes)
namespace mascot {
class AttributeValueDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<AttributeValue>
      _instance;
  bool boolvalue_;
  ::google::protobuf::int64 intvalue_;
  double doublevalue_;
  ::google::protobuf::internal::ArenaStringPtr stringvalue_;
  const ::mascot::ListOfBools* boollistvalue_;
  const ::mascot::ListOfInts* intlistvalue_;
  const ::mascot::ListOfDoubles* doublelistvalue_;
  const ::mascot::ListOfStrings* stringlistvalue_;
  const ::mascot::MatrixOfBools* boolmatrixvalue_;
  const ::mascot::MatrixOfInts* intmatrixvalue_;
  const ::mascot::MatrixOfDoubles* doublematrixvalue_;
  const ::mascot::MatrixOfStrings* stringmatrixvalue_;
} _AttributeValue_default_instance_;
}  // namespace mascot
namespace protobuf_value_2eproto {
void InitDefaultsAttributeValueImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsListOfBools();
  protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsListOfInts();
  protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsListOfDoubles();
  protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsListOfStrings();
  protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsMatrixOfBools();
  protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsMatrixOfInts();
  protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsMatrixOfDoubles();
  protobuf_complex_5fdata_5ftypes_2eproto::InitDefaultsMatrixOfStrings();
  {
    void* ptr = &::mascot::_AttributeValue_default_instance_;
    new (ptr) ::mascot::AttributeValue();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::AttributeValue::InitAsDefaultInstance();
}

void InitDefaultsAttributeValue() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsAttributeValueImpl);
}

::google::protobuf::Metadata file_level_metadata[1];

const ::google::protobuf::uint32 TableStruct::offsets[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeValue, _internal_metadata_),
  ~0u,  // no _extensions_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeValue, _oneof_case_[0]),
  ~0u,  // no _weak_field_map_
  offsetof(::mascot::AttributeValueDefaultTypeInternal, boolvalue_),
  offsetof(::mascot::AttributeValueDefaultTypeInternal, intvalue_),
  offsetof(::mascot::AttributeValueDefaultTypeInternal, doublevalue_),
  offsetof(::mascot::AttributeValueDefaultTypeInternal, stringvalue_),
  offsetof(::mascot::AttributeValueDefaultTypeInternal, boollistvalue_),
  offsetof(::mascot::AttributeValueDefaultTypeInternal, intlistvalue_),
  offsetof(::mascot::AttributeValueDefaultTypeInternal, doublelistvalue_),
  offsetof(::mascot::AttributeValueDefaultTypeInternal, stringlistvalue_),
  offsetof(::mascot::AttributeValueDefaultTypeInternal, boolmatrixvalue_),
  offsetof(::mascot::AttributeValueDefaultTypeInternal, intmatrixvalue_),
  offsetof(::mascot::AttributeValueDefaultTypeInternal, doublematrixvalue_),
  offsetof(::mascot::AttributeValueDefaultTypeInternal, stringmatrixvalue_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeValue, value_),
};
static const ::google::protobuf::internal::MigrationSchema schemas[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
  { 0, -1, sizeof(::mascot::AttributeValue)},
};

static ::google::protobuf::Message const * const file_default_instances[] = {
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_AttributeValue_default_instance_),
};

void protobuf_AssignDescriptors() {
  AddDescriptors();
  ::google::protobuf::MessageFactory* factory = NULL;
  AssignDescriptors(
      "value.proto", schemas, file_default_instances, TableStruct::offsets, factory,
      file_level_metadata, NULL, NULL);
}

void protobuf_AssignDescriptorsOnce() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &protobuf_AssignDescriptors);
}

void protobuf_RegisterTypes(const ::std::string&) GOOGLE_PROTOBUF_ATTRIBUTE_COLD;
void protobuf_RegisterTypes(const ::std::string&) {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::internal::RegisterAllTypes(file_level_metadata, 1);
}

void AddDescriptorsImpl() {
  InitDefaults();
  static const char descriptor[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
      "\n\013value.proto\022\006mascot\032\030complex_data_type"
      "s.proto\"\374\003\n\016AttributeValue\022\023\n\tboolValue\030"
      "\001 \001(\010H\000\022\022\n\010intValue\030\002 \001(\003H\000\022\025\n\013doubleVal"
      "ue\030\003 \001(\001H\000\022\025\n\013stringValue\030\004 \001(\tH\000\022,\n\rboo"
      "lListValue\030\005 \001(\0132\023.mascot.ListOfBoolsH\000\022"
      "*\n\014intListValue\030\006 \001(\0132\022.mascot.ListOfInt"
      "sH\000\0220\n\017doubleListValue\030\007 \001(\0132\025.mascot.Li"
      "stOfDoublesH\000\0220\n\017stringListValue\030\010 \001(\0132\025"
      ".mascot.ListOfStringsH\000\0220\n\017boolMatrixVal"
      "ue\030\t \001(\0132\025.mascot.MatrixOfBoolsH\000\022.\n\016int"
      "MatrixValue\030\n \001(\0132\024.mascot.MatrixOfIntsH"
      "\000\0224\n\021doubleMatrixValue\030\013 \001(\0132\027.mascot.Ma"
      "trixOfDoublesH\000\0224\n\021stringMatrixValue\030\014 \001"
      "(\0132\027.mascot.MatrixOfStringsH\000B\007\n\005valueb\006"
      "proto3"
  };
  ::google::protobuf::DescriptorPool::InternalAddGeneratedFile(
      descriptor, 566);
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedFile(
    "value.proto", &protobuf_RegisterTypes);
  ::protobuf_complex_5fdata_5ftypes_2eproto::AddDescriptors();
}

void AddDescriptors() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &AddDescriptorsImpl);
}
// Force AddDescriptors() to be called at dynamic initialization time.
struct StaticDescriptorInitializer {
  StaticDescriptorInitializer() {
    AddDescriptors();
  }
} static_descriptor_initializer;
}  // namespace protobuf_value_2eproto
namespace mascot {

// ===================================================================

void AttributeValue::InitAsDefaultInstance() {
  ::mascot::_AttributeValue_default_instance_.boolvalue_ = false;
  ::mascot::_AttributeValue_default_instance_.intvalue_ = GOOGLE_LONGLONG(0);
  ::mascot::_AttributeValue_default_instance_.doublevalue_ = 0;
  ::mascot::_AttributeValue_default_instance_.stringvalue_.UnsafeSetDefault(
      &::google::protobuf::internal::GetEmptyStringAlreadyInited());
  ::mascot::_AttributeValue_default_instance_.boollistvalue_ = const_cast< ::mascot::ListOfBools*>(
      ::mascot::ListOfBools::internal_default_instance());
  ::mascot::_AttributeValue_default_instance_.intlistvalue_ = const_cast< ::mascot::ListOfInts*>(
      ::mascot::ListOfInts::internal_default_instance());
  ::mascot::_AttributeValue_default_instance_.doublelistvalue_ = const_cast< ::mascot::ListOfDoubles*>(
      ::mascot::ListOfDoubles::internal_default_instance());
  ::mascot::_AttributeValue_default_instance_.stringlistvalue_ = const_cast< ::mascot::ListOfStrings*>(
      ::mascot::ListOfStrings::internal_default_instance());
  ::mascot::_AttributeValue_default_instance_.boolmatrixvalue_ = const_cast< ::mascot::MatrixOfBools*>(
      ::mascot::MatrixOfBools::internal_default_instance());
  ::mascot::_AttributeValue_default_instance_.intmatrixvalue_ = const_cast< ::mascot::MatrixOfInts*>(
      ::mascot::MatrixOfInts::internal_default_instance());
  ::mascot::_AttributeValue_default_instance_.doublematrixvalue_ = const_cast< ::mascot::MatrixOfDoubles*>(
      ::mascot::MatrixOfDoubles::internal_default_instance());
  ::mascot::_AttributeValue_default_instance_.stringmatrixvalue_ = const_cast< ::mascot::MatrixOfStrings*>(
      ::mascot::MatrixOfStrings::internal_default_instance());
}
void AttributeValue::set_allocated_boollistvalue(::mascot::ListOfBools* boollistvalue) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  clear_value();
  if (boollistvalue) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      boollistvalue = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, boollistvalue, submessage_arena);
    }
    set_has_boollistvalue();
    value_.boollistvalue_ = boollistvalue;
  }
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeValue.boolListValue)
}
void AttributeValue::clear_boollistvalue() {
  if (has_boollistvalue()) {
    delete value_.boollistvalue_;
    clear_has_value();
  }
}
void AttributeValue::set_allocated_intlistvalue(::mascot::ListOfInts* intlistvalue) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  clear_value();
  if (intlistvalue) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      intlistvalue = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, intlistvalue, submessage_arena);
    }
    set_has_intlistvalue();
    value_.intlistvalue_ = intlistvalue;
  }
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeValue.intListValue)
}
void AttributeValue::clear_intlistvalue() {
  if (has_intlistvalue()) {
    delete value_.intlistvalue_;
    clear_has_value();
  }
}
void AttributeValue::set_allocated_doublelistvalue(::mascot::ListOfDoubles* doublelistvalue) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  clear_value();
  if (doublelistvalue) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      doublelistvalue = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, doublelistvalue, submessage_arena);
    }
    set_has_doublelistvalue();
    value_.doublelistvalue_ = doublelistvalue;
  }
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeValue.doubleListValue)
}
void AttributeValue::clear_doublelistvalue() {
  if (has_doublelistvalue()) {
    delete value_.doublelistvalue_;
    clear_has_value();
  }
}
void AttributeValue::set_allocated_stringlistvalue(::mascot::ListOfStrings* stringlistvalue) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  clear_value();
  if (stringlistvalue) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      stringlistvalue = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, stringlistvalue, submessage_arena);
    }
    set_has_stringlistvalue();
    value_.stringlistvalue_ = stringlistvalue;
  }
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeValue.stringListValue)
}
void AttributeValue::clear_stringlistvalue() {
  if (has_stringlistvalue()) {
    delete value_.stringlistvalue_;
    clear_has_value();
  }
}
void AttributeValue::set_allocated_boolmatrixvalue(::mascot::MatrixOfBools* boolmatrixvalue) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  clear_value();
  if (boolmatrixvalue) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      boolmatrixvalue = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, boolmatrixvalue, submessage_arena);
    }
    set_has_boolmatrixvalue();
    value_.boolmatrixvalue_ = boolmatrixvalue;
  }
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeValue.boolMatrixValue)
}
void AttributeValue::clear_boolmatrixvalue() {
  if (has_boolmatrixvalue()) {
    delete value_.boolmatrixvalue_;
    clear_has_value();
  }
}
void AttributeValue::set_allocated_intmatrixvalue(::mascot::MatrixOfInts* intmatrixvalue) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  clear_value();
  if (intmatrixvalue) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      intmatrixvalue = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, intmatrixvalue, submessage_arena);
    }
    set_has_intmatrixvalue();
    value_.intmatrixvalue_ = intmatrixvalue;
  }
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeValue.intMatrixValue)
}
void AttributeValue::clear_intmatrixvalue() {
  if (has_intmatrixvalue()) {
    delete value_.intmatrixvalue_;
    clear_has_value();
  }
}
void AttributeValue::set_allocated_doublematrixvalue(::mascot::MatrixOfDoubles* doublematrixvalue) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  clear_value();
  if (doublematrixvalue) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      doublematrixvalue = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, doublematrixvalue, submessage_arena);
    }
    set_has_doublematrixvalue();
    value_.doublematrixvalue_ = doublematrixvalue;
  }
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeValue.doubleMatrixValue)
}
void AttributeValue::clear_doublematrixvalue() {
  if (has_doublematrixvalue()) {
    delete value_.doublematrixvalue_;
    clear_has_value();
  }
}
void AttributeValue::set_allocated_stringmatrixvalue(::mascot::MatrixOfStrings* stringmatrixvalue) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  clear_value();
  if (stringmatrixvalue) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      stringmatrixvalue = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, stringmatrixvalue, submessage_arena);
    }
    set_has_stringmatrixvalue();
    value_.stringmatrixvalue_ = stringmatrixvalue;
  }
  // @@protoc_insertion_point(field_set_allocated:mascot.AttributeValue.stringMatrixValue)
}
void AttributeValue::clear_stringmatrixvalue() {
  if (has_stringmatrixvalue()) {
    delete value_.stringmatrixvalue_;
    clear_has_value();
  }
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int AttributeValue::kBoolValueFieldNumber;
const int AttributeValue::kIntValueFieldNumber;
const int AttributeValue::kDoubleValueFieldNumber;
const int AttributeValue::kStringValueFieldNumber;
const int AttributeValue::kBoolListValueFieldNumber;
const int AttributeValue::kIntListValueFieldNumber;
const int AttributeValue::kDoubleListValueFieldNumber;
const int AttributeValue::kStringListValueFieldNumber;
const int AttributeValue::kBoolMatrixValueFieldNumber;
const int AttributeValue::kIntMatrixValueFieldNumber;
const int AttributeValue::kDoubleMatrixValueFieldNumber;
const int AttributeValue::kStringMatrixValueFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

AttributeValue::AttributeValue()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_value_2eproto::InitDefaultsAttributeValue();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.AttributeValue)
}
AttributeValue::AttributeValue(const AttributeValue& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  clear_has_value();
  switch (from.value_case()) {
    case kBoolValue: {
      set_boolvalue(from.boolvalue());
      break;
    }
    case kIntValue: {
      set_intvalue(from.intvalue());
      break;
    }
    case kDoubleValue: {
      set_doublevalue(from.doublevalue());
      break;
    }
    case kStringValue: {
      set_stringvalue(from.stringvalue());
      break;
    }
    case kBoolListValue: {
      mutable_boollistvalue()->::mascot::ListOfBools::MergeFrom(from.boollistvalue());
      break;
    }
    case kIntListValue: {
      mutable_intlistvalue()->::mascot::ListOfInts::MergeFrom(from.intlistvalue());
      break;
    }
    case kDoubleListValue: {
      mutable_doublelistvalue()->::mascot::ListOfDoubles::MergeFrom(from.doublelistvalue());
      break;
    }
    case kStringListValue: {
      mutable_stringlistvalue()->::mascot::ListOfStrings::MergeFrom(from.stringlistvalue());
      break;
    }
    case kBoolMatrixValue: {
      mutable_boolmatrixvalue()->::mascot::MatrixOfBools::MergeFrom(from.boolmatrixvalue());
      break;
    }
    case kIntMatrixValue: {
      mutable_intmatrixvalue()->::mascot::MatrixOfInts::MergeFrom(from.intmatrixvalue());
      break;
    }
    case kDoubleMatrixValue: {
      mutable_doublematrixvalue()->::mascot::MatrixOfDoubles::MergeFrom(from.doublematrixvalue());
      break;
    }
    case kStringMatrixValue: {
      mutable_stringmatrixvalue()->::mascot::MatrixOfStrings::MergeFrom(from.stringmatrixvalue());
      break;
    }
    case VALUE_NOT_SET: {
      break;
    }
  }
  // @@protoc_insertion_point(copy_constructor:mascot.AttributeValue)
}

void AttributeValue::SharedCtor() {
  clear_has_value();
  _cached_size_ = 0;
}

AttributeValue::~AttributeValue() {
  // @@protoc_insertion_point(destructor:mascot.AttributeValue)
  SharedDtor();
}

void AttributeValue::SharedDtor() {
  if (has_value()) {
    clear_value();
  }
}

void AttributeValue::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* AttributeValue::descriptor() {
  ::protobuf_value_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_value_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const AttributeValue& AttributeValue::default_instance() {
  ::protobuf_value_2eproto::InitDefaultsAttributeValue();
  return *internal_default_instance();
}

AttributeValue* AttributeValue::New(::google::protobuf::Arena* arena) const {
  AttributeValue* n = new AttributeValue;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void AttributeValue::clear_value() {
// @@protoc_insertion_point(one_of_clear_start:mascot.AttributeValue)
  switch (value_case()) {
    case kBoolValue: {
      // No need to clear
      break;
    }
    case kIntValue: {
      // No need to clear
      break;
    }
    case kDoubleValue: {
      // No need to clear
      break;
    }
    case kStringValue: {
      value_.stringvalue_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
      break;
    }
    case kBoolListValue: {
      delete value_.boollistvalue_;
      break;
    }
    case kIntListValue: {
      delete value_.intlistvalue_;
      break;
    }
    case kDoubleListValue: {
      delete value_.doublelistvalue_;
      break;
    }
    case kStringListValue: {
      delete value_.stringlistvalue_;
      break;
    }
    case kBoolMatrixValue: {
      delete value_.boolmatrixvalue_;
      break;
    }
    case kIntMatrixValue: {
      delete value_.intmatrixvalue_;
      break;
    }
    case kDoubleMatrixValue: {
      delete value_.doublematrixvalue_;
      break;
    }
    case kStringMatrixValue: {
      delete value_.stringmatrixvalue_;
      break;
    }
    case VALUE_NOT_SET: {
      break;
    }
  }
  _oneof_case_[0] = VALUE_NOT_SET;
}


void AttributeValue::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.AttributeValue)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  clear_value();
  _internal_metadata_.Clear();
}

bool AttributeValue::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.AttributeValue)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // bool boolValue = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {
          clear_value();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   bool, ::google::protobuf::internal::WireFormatLite::TYPE_BOOL>(
                 input, &value_.boolvalue_)));
          set_has_boolvalue();
        } else {
          goto handle_unusual;
        }
        break;
      }

      // int64 intValue = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(16u /* 16 & 0xFF */)) {
          clear_value();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int64, ::google::protobuf::internal::WireFormatLite::TYPE_INT64>(
                 input, &value_.intvalue_)));
          set_has_intvalue();
        } else {
          goto handle_unusual;
        }
        break;
      }

      // double doubleValue = 3;
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(25u /* 25 & 0xFF */)) {
          clear_value();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   double, ::google::protobuf::internal::WireFormatLite::TYPE_DOUBLE>(
                 input, &value_.doublevalue_)));
          set_has_doublevalue();
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string stringValue = 4;
      case 4: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(34u /* 34 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_stringvalue()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->stringvalue().data(), static_cast<int>(this->stringvalue().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.AttributeValue.stringValue"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.ListOfBools boolListValue = 5;
      case 5: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(42u /* 42 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_boollistvalue()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.ListOfInts intListValue = 6;
      case 6: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(50u /* 50 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_intlistvalue()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.ListOfDoubles doubleListValue = 7;
      case 7: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(58u /* 58 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_doublelistvalue()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.ListOfStrings stringListValue = 8;
      case 8: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(66u /* 66 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_stringlistvalue()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.MatrixOfBools boolMatrixValue = 9;
      case 9: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(74u /* 74 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_boolmatrixvalue()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.MatrixOfInts intMatrixValue = 10;
      case 10: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(82u /* 82 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_intmatrixvalue()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.MatrixOfDoubles doubleMatrixValue = 11;
      case 11: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(90u /* 90 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_doublematrixvalue()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.MatrixOfStrings stringMatrixValue = 12;
      case 12: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(98u /* 98 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_stringmatrixvalue()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.AttributeValue)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.AttributeValue)
  return false;
#undef DO_
}

void AttributeValue::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.AttributeValue)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // bool boolValue = 1;
  if (has_boolvalue()) {
    ::google::protobuf::internal::WireFormatLite::WriteBool(1, this->boolvalue(), output);
  }

  // int64 intValue = 2;
  if (has_intvalue()) {
    ::google::protobuf::internal::WireFormatLite::WriteInt64(2, this->intvalue(), output);
  }

  // double doubleValue = 3;
  if (has_doublevalue()) {
    ::google::protobuf::internal::WireFormatLite::WriteDouble(3, this->doublevalue(), output);
  }

  // string stringValue = 4;
  if (has_stringvalue()) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->stringvalue().data(), static_cast<int>(this->stringvalue().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeValue.stringValue");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      4, this->stringvalue(), output);
  }

  // .mascot.ListOfBools boolListValue = 5;
  if (has_boollistvalue()) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      5, *value_.boollistvalue_, output);
  }

  // .mascot.ListOfInts intListValue = 6;
  if (has_intlistvalue()) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      6, *value_.intlistvalue_, output);
  }

  // .mascot.ListOfDoubles doubleListValue = 7;
  if (has_doublelistvalue()) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      7, *value_.doublelistvalue_, output);
  }

  // .mascot.ListOfStrings stringListValue = 8;
  if (has_stringlistvalue()) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      8, *value_.stringlistvalue_, output);
  }

  // .mascot.MatrixOfBools boolMatrixValue = 9;
  if (has_boolmatrixvalue()) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      9, *value_.boolmatrixvalue_, output);
  }

  // .mascot.MatrixOfInts intMatrixValue = 10;
  if (has_intmatrixvalue()) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      10, *value_.intmatrixvalue_, output);
  }

  // .mascot.MatrixOfDoubles doubleMatrixValue = 11;
  if (has_doublematrixvalue()) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      11, *value_.doublematrixvalue_, output);
  }

  // .mascot.MatrixOfStrings stringMatrixValue = 12;
  if (has_stringmatrixvalue()) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      12, *value_.stringmatrixvalue_, output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.AttributeValue)
}

::google::protobuf::uint8* AttributeValue::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.AttributeValue)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // bool boolValue = 1;
  if (has_boolvalue()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteBoolToArray(1, this->boolvalue(), target);
  }

  // int64 intValue = 2;
  if (has_intvalue()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteInt64ToArray(2, this->intvalue(), target);
  }

  // double doubleValue = 3;
  if (has_doublevalue()) {
    target = ::google::protobuf::internal::WireFormatLite::WriteDoubleToArray(3, this->doublevalue(), target);
  }

  // string stringValue = 4;
  if (has_stringvalue()) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->stringvalue().data(), static_cast<int>(this->stringvalue().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeValue.stringValue");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        4, this->stringvalue(), target);
  }

  // .mascot.ListOfBools boolListValue = 5;
  if (has_boollistvalue()) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        5, *value_.boollistvalue_, deterministic, target);
  }

  // .mascot.ListOfInts intListValue = 6;
  if (has_intlistvalue()) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        6, *value_.intlistvalue_, deterministic, target);
  }

  // .mascot.ListOfDoubles doubleListValue = 7;
  if (has_doublelistvalue()) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        7, *value_.doublelistvalue_, deterministic, target);
  }

  // .mascot.ListOfStrings stringListValue = 8;
  if (has_stringlistvalue()) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        8, *value_.stringlistvalue_, deterministic, target);
  }

  // .mascot.MatrixOfBools boolMatrixValue = 9;
  if (has_boolmatrixvalue()) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        9, *value_.boolmatrixvalue_, deterministic, target);
  }

  // .mascot.MatrixOfInts intMatrixValue = 10;
  if (has_intmatrixvalue()) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        10, *value_.intmatrixvalue_, deterministic, target);
  }

  // .mascot.MatrixOfDoubles doubleMatrixValue = 11;
  if (has_doublematrixvalue()) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        11, *value_.doublematrixvalue_, deterministic, target);
  }

  // .mascot.MatrixOfStrings stringMatrixValue = 12;
  if (has_stringmatrixvalue()) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        12, *value_.stringmatrixvalue_, deterministic, target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.AttributeValue)
  return target;
}

size_t AttributeValue::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.AttributeValue)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  switch (value_case()) {
    // bool boolValue = 1;
    case kBoolValue: {
      total_size += 1 + 1;
      break;
    }
    // int64 intValue = 2;
    case kIntValue: {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::Int64Size(
          this->intvalue());
      break;
    }
    // double doubleValue = 3;
    case kDoubleValue: {
      total_size += 1 + 8;
      break;
    }
    // string stringValue = 4;
    case kStringValue: {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::StringSize(
          this->stringvalue());
      break;
    }
    // .mascot.ListOfBools boolListValue = 5;
    case kBoolListValue: {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          *value_.boollistvalue_);
      break;
    }
    // .mascot.ListOfInts intListValue = 6;
    case kIntListValue: {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          *value_.intlistvalue_);
      break;
    }
    // .mascot.ListOfDoubles doubleListValue = 7;
    case kDoubleListValue: {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          *value_.doublelistvalue_);
      break;
    }
    // .mascot.ListOfStrings stringListValue = 8;
    case kStringListValue: {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          *value_.stringlistvalue_);
      break;
    }
    // .mascot.MatrixOfBools boolMatrixValue = 9;
    case kBoolMatrixValue: {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          *value_.boolmatrixvalue_);
      break;
    }
    // .mascot.MatrixOfInts intMatrixValue = 10;
    case kIntMatrixValue: {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          *value_.intmatrixvalue_);
      break;
    }
    // .mascot.MatrixOfDoubles doubleMatrixValue = 11;
    case kDoubleMatrixValue: {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          *value_.doublematrixvalue_);
      break;
    }
    // .mascot.MatrixOfStrings stringMatrixValue = 12;
    case kStringMatrixValue: {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          *value_.stringmatrixvalue_);
      break;
    }
    case VALUE_NOT_SET: {
      break;
    }
  }
  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void AttributeValue::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.AttributeValue)
  GOOGLE_DCHECK_NE(&from, this);
  const AttributeValue* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const AttributeValue>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.AttributeValue)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.AttributeValue)
    MergeFrom(*source);
  }
}

void AttributeValue::MergeFrom(const AttributeValue& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.AttributeValue)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  switch (from.value_case()) {
    case kBoolValue: {
      set_boolvalue(from.boolvalue());
      break;
    }
    case kIntValue: {
      set_intvalue(from.intvalue());
      break;
    }
    case kDoubleValue: {
      set_doublevalue(from.doublevalue());
      break;
    }
    case kStringValue: {
      set_stringvalue(from.stringvalue());
      break;
    }
    case kBoolListValue: {
      mutable_boollistvalue()->::mascot::ListOfBools::MergeFrom(from.boollistvalue());
      break;
    }
    case kIntListValue: {
      mutable_intlistvalue()->::mascot::ListOfInts::MergeFrom(from.intlistvalue());
      break;
    }
    case kDoubleListValue: {
      mutable_doublelistvalue()->::mascot::ListOfDoubles::MergeFrom(from.doublelistvalue());
      break;
    }
    case kStringListValue: {
      mutable_stringlistvalue()->::mascot::ListOfStrings::MergeFrom(from.stringlistvalue());
      break;
    }
    case kBoolMatrixValue: {
      mutable_boolmatrixvalue()->::mascot::MatrixOfBools::MergeFrom(from.boolmatrixvalue());
      break;
    }
    case kIntMatrixValue: {
      mutable_intmatrixvalue()->::mascot::MatrixOfInts::MergeFrom(from.intmatrixvalue());
      break;
    }
    case kDoubleMatrixValue: {
      mutable_doublematrixvalue()->::mascot::MatrixOfDoubles::MergeFrom(from.doublematrixvalue());
      break;
    }
    case kStringMatrixValue: {
      mutable_stringmatrixvalue()->::mascot::MatrixOfStrings::MergeFrom(from.stringmatrixvalue());
      break;
    }
    case VALUE_NOT_SET: {
      break;
    }
  }
}

void AttributeValue::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.AttributeValue)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void AttributeValue::CopyFrom(const AttributeValue& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.AttributeValue)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool AttributeValue::IsInitialized() const {
  return true;
}

void AttributeValue::Swap(AttributeValue* other) {
  if (other == this) return;
  InternalSwap(other);
}
void AttributeValue::InternalSwap(AttributeValue* other) {
  using std::swap;
  swap(value_, other->value_);
  swap(_oneof_case_[0], other->_oneof_case_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata AttributeValue::GetMetadata() const {
  protobuf_value_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_value_2eproto::file_level_metadata[kIndexInFileMessages];
}


// @@protoc_insertion_point(namespace_scope)
}  // namespace mascot

// @@protoc_insertion_point(global_scope)
